on cleanup
  if the machineType <> 256 then
    releaseRearWindow()
  end if
end

on blackout
  global black
  initRearWindow()
  coverDesktop(black)
end

on initRearWindow
  global rwObj, gMaxColors, deskTopPattern, black
  set x to the colorDepth
  if x >= 8 then
    set gMaxColors to 255
  end if
  if x = 4 then
    set gMaxColors to 15
  end if
  if x = 2 then
    set gMaxColors to 3
  end if
  if x = 1 then
    set gMaxColors to 0
  end if
  initGlobals()
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  makeObjIfNeeded()
end

on releaseRearWindow
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
end

on initGlobals
  global white, ltGray, gray, dkGray, black, deskTopPattern
  set white to -1
  set ltGray to -2
  set gray to -3
  set dkGray to -4
  set black to -5
  set deskTopPattern to -99
end

on displayAppName
  global rwObj
  set returnStr to rwObj(mGetAppName)
end

on coverDesktop patVar
  global rwObj
  makeObjIfNeeded()
  rwObj(mPatToWindow, patVar)
end

on loadPICT
  global rwObj
  makeObjIfNeeded()
  set fileName to the pathName & "Background.PICT"
  set retValue to rwObj(mPICTToWindow, fileName, 1, -99)
  if value(retValue) < 0 then
    alert("System error" && retValue && "trying to load PICT file" && QUOTE & fileName & QUOTE)
    stopMovie()
    exit
  end if
end

on loadCast castName
  global rwObj
  makeObjIfNeeded()
  set myPic to the picture of cast castName
  set retValue to rwObj(mCastToWindow, myPic, 1, -99)
  if value(retValue) < 0 then
    alert("Error trying to load castMember" && QUOTE & castName & QUOTE)
    stopMovie()
    exit
  end if
end

on UnCoverDesktop
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  unLoad()
end

on makeObjIfNeeded
  global rwObj
  if not objectp(rwObj) then
    set rwObj to RearWindow(mnew, "M")
    if value(rwObj) < 0 then
      alert("System error" && rwObj && "trying to create the RearWindow object in RAM (multiple-monitor config).")
      stopMovie()
      exit
    end if
    writeStageAndScreenBounds()
    if the freeBlock < rwObj(mGetMemoryNeeded) then
      if objectp(rwObj) then
        rwObj(mdispose)
        set rwObj to RearWindow(mnew, "S")
      end if
      if value(rwObj) < 0 then
        alert("System error" && rwObj && "trying to create the RearWindow object in RAM (single-monitor config).")
        stopMovie()
        exit
      end if
      writeStageAndScreenBounds()
    end if
  end if
end

on writeStageAndScreenBounds
end

on fillWithIndexColor
  global rwObj
  makeObjIfNeeded()
  set patVar to value(field "colorIndex")
  rwObj(mIndexColorToWindow, patVar)
end

on fillWithRGBColor
  global rwObj
  makeObjIfNeeded()
  rwObj(mRGBColorToWindow, 10000, 25000, 65000)
end

on bumpCIndex direction
  global rwObj, white, gMaxColors
  set cIndex to value(field "colorIndex")
  if integerp(cIndex) then
    set cIndex to cIndex + direction
    if (cIndex < 0) or (cIndex > gMaxColors) then
      exit
    else
      put string(cIndex) into field "colorIndex"
      if cIndex then
        makeObjIfNeeded()
        rwObj(mIndexColorToWindow, cIndex)
      else
        coverDesktop(white)
      end if
      repeat while the stillDown
        set cIndex to cIndex + direction
        if (cIndex < 0) or (cIndex > gMaxColors) then
          exit
          next repeat
        end if
        put string(cIndex) into field "colorIndex"
        if cIndex then
          makeObjIfNeeded()
          rwObj(mIndexColorToWindow, cIndex)
          next repeat
        end if
        coverDesktop(white)
      end repeat
    end if
  end if
end

on wait n
  startTimer()
  repeat while the timer < n
  end repeat
end
